<script context="module" lang="ts">
	import { enhance } from '$lib/form';
	import type { Load } from '@sveltejs/kit';

	// see https://kit.svelte.dev/docs#loading
	export const load: Load = async ({ fetch, session, page }) => {
		const hasUserInfo = !!Object.values(session).length;
		if (hasUserInfo) {
			return {
				props: {
					userInfo: session
				}
			};
		} else {
			if (page.path == '/auth' || page.path == '/dashboard') {
				return {};
			} else {
				return {
					status: 303,
					redirect: '/dashboard'
				};
			}
		}
	};
</script>

<script lang="ts">
	import { goto, invalidate, prefetch, prefetchRoutes } from '$app/navigation';
	import { getStores, navigating, page, session } from '$app/stores';
	import { base, assets } from '$app/paths';
	import { onDestroy, onMount } from 'svelte';
	import axios from 'axios';
	import { browser } from '$app/env';
	import LoadingCircle from '$lib/utils/LoadingCircle';
	let user = '9zack@mail.com';
	let pass = '123456';

	export let userInfo = {};
	const loading = new LoadingCircle();

	onMount(() => {
		if (userInfo && Object.values(userInfo).length) {
			loading.show();
		}
	});

	let error: { message: string };

	async function loginFn() {
		error = { message: '' };
		if (user && pass) {
			loading.show();
			try {
				const respLogin = await axios.post('/api/auth', { user, pass });
				const body = respLogin.data;
				if (body.status == 200) {
					if (browser) {
						// เรียกซ้ำ load functioin ในหน้า
						(window as any).location.reload();
					}
				}
			} catch (err) {
				error = err;
				loading.dispose();
			}
		} else {
			error = { message: '* Please input username and password' };
		}
	}
</script>

<svelte:head>
	<title>เข้าสู่ระบบ</title>
</svelte:head>

{#if userInfo && Object.values(userInfo).length}
	<div class="flex justify-center items-center flex-col h-full">
		<p>Loading...</p>
	</div>
{:else}
	<div
		class="min-h-screen flex items-center justify-center dark:bg-gray-800 bg-gray-50 py-12 px-4 sm:px-6 lg:px-8"
	>
		<div class="max-w-md w-full space-y-8">
			<div>
				<h2 class="mt-6 text-center text-3xl font-extrabold dark:text-white text-gray-900">
					เข้าสู่ระบบ
				</h2>
			</div>
			<div class="mt-8 space-y-6">
				<input type="hidden" name="remember" value="true" />
				<div class="rounded-md shadow-sm -space-y-px">
					<div>
						<label for="username" class="sr-only">Username</label>
						<input
							bind:value={user}
							id="username"
							name="user"
							type="text"
							autocomplete="Username"
							required
							class="appearance-none rounded-none relative block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-900 rounded-t-md focus:outline-none focus:ring-orange-500 focus:border-orange-500 focus:z-10 sm:text-sm"
							placeholder="Username"
						/>
					</div>
					<div>
						<label for="password" class="sr-only">Password</label>
						<input
							bind:value={pass}
							id="password"
							name="password"
							type="password"
							autocomplete="current-password"
							required
							class="appearance-none rounded-none relative block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-900 rounded-b-md focus:outline-none focus:ring-orange-500 focus:border-orange-500 focus:z-10 sm:text-sm"
							placeholder="Password"
						/>
					</div>
				</div>

				<div class="dark:text-red-400 text-red-500 py-2">{error?.message ? error.message : ''}</div>
				<div>
					<button
						on:click={loginFn}
						type="button"
						class="{user && pass
							? 'text-white dark:bg-gray-900 bg-orange-600 hover:bg-orange-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-orange-500'
							: 'bg-gray-500 text-white'} group relative w-full flex justify-center py-2 px-4 border border-transparent text-sm font-medium rounded-md"
					>
						<span class="absolute left-0 inset-y-0 flex items-center pl-3">
							<!-- Heroicon name: solid/lock-closed -->
							<svg
								class="h-5 w-5 dark:text-white text-orange-200 group-hover:text-orange-400"
								xmlns="http://www.w3.org/2000/svg"
								viewBox="0 0 20 20"
								fill="currentColor"
								aria-hidden="true"
							>
								<path
									fill-rule="evenodd"
									d="M5 9V7a5 5 0 0110 0v2a2 2 0 012 2v5a2 2 0 01-2 2H5a2 2 0 01-2-2v-5a2 2 0 012-2zm8-2v2H7V7a3 3 0 016 0z"
									clip-rule="evenodd"
								/>
							</svg>
						</span>
						Sign in
					</button>
				</div>
			</div>
		</div>
	</div>
{/if}
